'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.httpBase = exports.queryStringify = undefined;

var _Observable = require('rxjs/Observable');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var queryStringify = exports.queryStringify = function queryStringify(obj) {
  if (!obj) return '';
  var str = '';
  for (var i in obj) {
    str += i + '=' + obj[i] + '&';
  }
  return str.slice(0, -1);
};

var httpBase = exports.httpBase = function httpBase() {
  _classCallCheck(this, httpBase);

  var xhr = new XMLHttpRequest();
  this.send = function (method, address, params) {
    var headers = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

    method = method.toLowerCase();
    var query = void 0,
        sendQuery = '';
    if (params) query = queryStringify(params);
    return _Observable.Observable.create(function (ob) {
      xhr.onreadystatechange = function () {
        if (xhr.readyState === 4) {
          if (xhr.status === 0) {
            console.error('connect failure,status:' + xhr.status);
            return ob.error('err');
          }
          ob.next({ status: xhr.status, content: xhr.responseText });
        }
      };
      if (method === 'get') {
        if (query) address += '?' + query;
      } else {
        sendQuery = query;
        headers = Object.assign({ 'Content-type': 'application/x-www-form-urlencoded' }, headers);
      }
      //unsubscribe abort xhr:
      var old = ob.unsubscribe;
      ob.unsubscribe = function () {
        xhr.abort();
        old.call(ob);
      };

      //send msg:
      xhr.open(method, address);
      for (var i in headers) {
        xhr.setRequestHeader(i, headers[i]);
      }
      xhr.send(sendQuery);
    });
  };
};